#!/usr/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####



=pod
	client.cgi: pour modifier ou creer client
		
=cut

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Client;

#print header,start_html(-BGCOLOR => "#ffffff");

#declaration variables
#recup para
my @param=param();
if(!@param){
	print redirect("$CGIADR/login.cgi");
	}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
my $mess='';
#pour les factures
if(param('numfact')){$para{'numfact'} =param('numfact');} 
#pour les commandes
if(param("toupdate")){$para{"toupdate"} = param("toupdate");} 
#pour la transormation propal en commandes
if(param("idpropal")){$para{"idpropal"} = param("idpropal");} 
#pour creation d'un client utilisateur
if(param("userid")){$para{"userid"} = param("userid");} 	
my $login=param("username");
my $type=param("usertype");
my $clientid=param("clientid");
my $script = param('script');
my $boutonnavig = param('boutonnavig');


#autre variable
my ($clientnom,$clientnom2,$clientrue1,$clientrue2,$clientville,$clientcp,$email,
$tel1,$tel2, $clienttitre,$clientpays,$fax);

#ajouter ou modifier un client
if(param("validcrecli.x") || param("validmodcli.x")){	
	$clientnom=param("clientnomajout");		
	if(!$clientnom){$mess.="$messnomclinotok, "};
	$clientrue1 =param("clientrue1ajout");		
	if(!$clientrue1){$mess.="$messrueclinotok, "};
	$clientville =param("clientvilleajout");		
	if(!$clientville){$mess.="$messvilleclinotok, "};
	$clientcp = param("clientcpajout");	
	if(!$clientcp){$mess.="$messcpclinotok, "};
	#fin ctrl
	my $listechamps='';
	my @val = ();
	if(!$mess){				
		@val=(param('clientnom2ajout'),param('clientrue2ajout'),param('emailajout'),param('tel1ajout'),
		param('tel2ajout'),
		param('clienttitreajout'), param('clientpaysajout'),param('faxajout'));
		push(@val,$clientnom,$clientrue1,$clientville,$clientcp);

		($clientnom2,$clientrue2,$email,$tel1,$tel2, $clienttitre,$clientpays,$fax,
		$clientnom, $clientrue1,$clientville,$clientcp) = @val;
			
		#verrification de la non existence du mme enreg
          $listechamps='$clientnom2,$clientrue2,$email,$tel1,$tel2,$clienttitre,$clientpays,$fax,';
		  $listechamps .= '$clientnom,$clientrue1,$clientville,$clientcp,$clientid';  			 
		  my $cond = '';
		  #verifier que le client n'existe pas deja
		  foreach my $val(split(/,/,$listechamps)){
		  	my $clef = $val;
		  	$val =~ s/(\$\w+)/$1/gee;
		  	$val =~ s/(?<!\\)('|")/\\$1/g;
		  	$clef =~ s/\$//;		  	
		  	if($val && $clef !~ /clientid/){$cond .= "$clef like '$val' and ";}
		  }		 
		  #print p "cond = $cond";
		  $cond =~ s/and\s*$//;
		  if($clientid){$cond .= "and clientid <> $clientid";}
		  if(my ($cli) = &select_une_lig('clientid','client',$cond)){		  	
		  	$mess .= $messcliexiste;
		  }
	}
	if($mess && !$clientid){
		foreach my $para (@param){
			if ($para =~ /ajout$/){$para{$para} = param($para);}
		}
	}	
	if(!$mess){	
		#################	
		$listechamps  =~ s/\$//g;
		$listechamps = "(".$listechamps.")";	
		if(!$clientid){#ajouter			
			$clientid = &max("client","clientid") + 1;
			push(@val,$clientid);
			$mess=$messajoutcliok;			
			foreach my $val(@val){
				$val="'".$val."'";
			}
			my $listeval="(".join(",",@val).")";			
			&insert($listeval,$listechamps,"client");
			}		
		else{#modifier un client			
			$mess=$messmodcliok;
			my %hash=("clientnom2" =>$clientnom2,			
					"clientrue2" =>$clientrue2 ,
					"email" => $email,
					"tel1" =>$tel1 ,
					"tel2" =>$tel2,
					"clienttitre" =>$clienttitre ,
					"clientpays" => $clientpays,
			 		"clientnom" => $clientnom,
			 		"clientrue1" => $clientrue1,
			 		"clientville" => $clientville,
			 		"clientcp" => $clientcp,
					"fax" => $fax);
			#$champs,$idquestion, $refhach,$table )	
	 		&maj("clientid = $clientid",\%hash,"client");
	 	}
	 }
}
	 
####################################
#preparation des donnees a afficher
####################################

my @ramenechamps=();	 
#selection client	 
if($clientid){
	my $listechamps="clientnom,clientnom2,clientrue1,clientrue2,clientville,clientcp,email,";
	$listechamps .= "tel1,tel2,clienttitre,clientpays,fax";
	@ramenechamps=&select_une_lig($listechamps,"client","clientid=$clientid");
	foreach my $clef (@ramenechamps){	
		$clef =~ s/"/\&quot;/g;		
	}	
	($clientnom,$clientnom2,$clientrue1,$clientrue2,$clientville,$clientcp,$email,
    $tel1,$tel2, $clienttitre,$clientpays,$fax) =@ramenechamps;
} 		

#############################
#affichage client
#############################
&majClient($clientid,$type,$login,$titlecreatclient,$script,$boutonnavig,\%para,\@ramenechamps,$mess);
	 		
