#!/usr/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#appeller de l'ecran utilisateur qd on cliq sur le bouton modifier
#de la liste des utilisateurs fait par utilisateur.cgi
 
=pod
	pour creer un utlisateur		
=cut

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Utilisateur;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;


#declaration variables
#recup para	
my $login=param("username");
my $type=param("usertype");
my $mess = '';
my $userid = (param('userid') || 0);


#maj table user
#modif ou creation d'un utilisateur

  

if(param('validercreat') || param('validermodif')){			
	my $username=param("usernamemod");	
	my $userrole=param("userrolemod");	
	my $userlogin=param("userloginmod");
	my $userpasswd=param("userpasswdmod");
	my $userpassconfirm=param("userpasswdconfirmmod");
    my $clientiduser = param('clientidusermod');
    my $nomcomplet = param('nomcompletmod');
	#si resp et/ou datefact non renseign on entre pas
	#si un para est mal renseign on entre pas 
	if(!$username){$mess.="$messname, ";}
	if(!$userlogin){$mess.="$messlogin, ";}
	if(!$userpasswd){$mess.="$messmdp, ";}
	if (!$nomcomplet){$mess .= "$messnotwholename, ";}	
	if($userpasswd ne $userpassconfirm){$mess.="$messmdp, ";}
    #si type = client, alors le client doit exister
	if($userrole eq $customer && $clientiduser == -1){$mess .= "$messnocliandtypecli, ";}
	#pas deux fois le mme login
	my $cond=" userlogin = '$userlogin' ";
	if($userid){$cond.=" and userid <> $userid";}	
	if (my ($lig)=&select_une_lig("userlogin","user",$cond)){
		$mess.="$messlogexiste, ";
	}
	#un role ne peut tre associ qu' un seul nom et un seul nom complet
	#pas 2 fois mme nom et role
    $cond=" username = '$username' and userrole = '$userrole'";
	if($userid){$cond.=" and userid <> $userid";}
	if (my ($lig)=&select_une_lig("userlogin","user",$cond)){
		$mess.="$messnameroleexist, ";
	}
	#pas 2 fois mme nomcomplet et role
	$cond=" nomcomplet = '$nomcomplet' and userrole = '$userrole'";
	if($userid){$cond.=" and userid <> $userid";}
	if (my ($lig)=&select_une_lig("userlogin","user",$cond)){
		$mess.="$messnomcomproleexist, ";
	}
	if($mess){
		foreach my $para (@param){
			if($para =~ /mod$/){
				$para{$para}=param($para);
			}
		}
		#if($userid){$para{"userid"} = $userid;}
	}
						
	if(!$mess){#$mess = $messfct
		$userid=$userid?$userid:&max('user', 'userid') + 1;		
		my %hash;
		$clientiduser = $userrole eq $customer ? $clientiduser : "-1";		
		my @listechamps=('userid','username','userlogin','userpasswd','userrole','nomcomplet','clientiduser');
		my $salt = substr($userpasswd,0,2);	
        my $userpasswd = crypt($userpasswd, $salt);        		
		my @listeval =($userid,$username,$userlogin,$userpasswd,$userrole,$nomcomplet,$clientiduser);				
		for (my $i=0;$i < @listechamps; $i++){			
				$hash{$listechamps[$i]}= $listeval[$i];			
		}		
		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";		
		my $listechamps = "(".join(",",@listechamps).")";	
		if (param('validercreat')){
			$mess="$messcreatuserok";			
			&insert( $listeval,$listechamps,"user");			
		}
		
		else{#param('validermodif.x') cad update
			$mess="$messmodifuserok";			
		    &maj("userid = $userid",\%hash,"user");		    					 
		}		
	}			 
}

if($userid){$para{'userid'} = $userid;}			

##############################		
#preparation liste deroulante
##############################

#liste des roles
my %tabuserrole;
tie %tabuserrole,"Tie::IxHash";
%tabuserrole=&init_statfact("$LIBAD/usertype.conf");

#liste des clients
#pour la liste des noms
my $liste_champs= "clientnom,clientnom2, clientville, clientcp";
my %tabcli;
tie %tabcli,"Tie::IxHash"; 
$tabcli{"-1"}= $messchoicecustomer; 	
%tabcli= (%tabcli,&liste("client", "clientid",$liste_champs,"clientid >= 1","clientnom"));
	

#prparation des donnees
my @ramenechamps =();
#rcupration donnes facture
if($userid){	#recup entete	
  my $listechamps = "username, userrole, userlogin, ";
  $listechamps .= "clientiduser,nomcomplet";  
  my $table = " user ";
  my $cond = "  userid = $userid";   
  @ramenechamps=&select_une_lig($listechamps,$table,$cond);
  foreach my $clef (@ramenechamps){	
		$clef =~ s/"/\&quot;/g;		
  }
  if(exists $para{"usernamemod"}){
  	(@ramenechamps)= @para{"usernamemod","userrolemod","userloginmod","clientidusermod",
  	"nomcompletmod"};
  	
  }         
}


############################
#affichage
###########################
&AffichCreatUser($userid,$type,$login,\%para,\@ramenechamps,
    \%tabcli,\%tabuserrole,$mess);
	


