=pod

package de variables pour les factures
propres au theme UNGI

=cut

package UNGI::Editfacture;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&editfact);	
		
}

use vars  @EXPORT;



##############
#la facture
#############
#entete d'une facture non duplique

my $enteteFacture = q|
<!-- debut entete facture -->
<html>
<body bgcolor=#ffffff>
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr> 
    <td valign="top" width="54%"> 
      <img src="%$BASEADHTMLTHEME%/icones/%$logofacture%" width="150" height="52">
    </td>
    <td width="46%" valign="top"> 
      <table width="80%" border="0" cellspacing="0" cellpadding="0" align="right">
        <tr>
          <td width="68%"> 
            <div align="right"><b><font face="Arial, Helvetica, sans-serif" size="2">Facture 
              :&nbsp;&nbsp; </font></b></div>
          </td>
          <td width="32%" bgcolor="#FFEECC" height="30" align="center">%$numfact%</td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td valign="top" width="54%">
      %$coord1%
    </td>
    <td height="206" width="46%" valign="top"> 
      <table width="100%" border="0" cellspacing="1" cellpadding="2" height="121" bgcolor="#000000" align="left">
        <tr> 
          <td bgcolor="#FFEECC" valign="top">            
            <font face="Arial, Helvetica, sans-serif" size="2"><b>&nbsp;&nbsp;Adress&eacute; 
              &agrave; :</font><br>
              <center>
              <b><font face="Arial, Helvetica, sans-serif" size="2">
              %$clientnom% </font><br>
              <font face="Arial, Helvetica, sans-serif" size="2">
              %$clientnom2%<br>
              <font face="Arial, Helvetica, sans-serif" size="2">
              %$clienttitre%<br>
              </b></font><b><font face="Arial, Helvetica, sans-serif" size="2">%$clientrue1%<br>
              </b></font><b><font face="Arial, Helvetica, sans-serif" size="2">%$clientrue2%<br>
              </font></b><b><font face="Arial, Helvetica, sans-serif" size="2">%$clientcp% %$clientville%</font></b>
             <br></b></font><b><font face="Arial, Helvetica, sans-serif" size="2">%$clientpays%<br>
             </center>
            </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<hr width="100%">
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr> 
    <td valign="top" width="54%"> 
      <p>&nbsp;</p>
      </td>
    <td width="46%" valign="top"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="3"><b><font size="4">FACTURE 
        </font> </b> </font></div>
    </td>
  </tr>
  <tr> 
  <td valign="top" width="54%">&nbsp;</td>
    <td width="46%" valign="top"> <br>
      <table width="100%" border="0" height="70" align="left" cellpadding="0" cellspacing="0">
        <tr> 
          <td valign="middle" width="45%" bgcolor="#999999"> 
            <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">Date</font></b></div>
          </td>
          <td valign="middle" width="55%" bgcolor="#FFEECC"> 
            <div align="center">%$datefact%</div>
          </td>
        </tr>
        <tr> 
          <td valign="middle" width="45%" bgcolor="#999999"> 
            <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">R&eacute;f. 
              commande</font></b></div>
          </td>
          <td valign="middle" width="55%" bgcolor="#FFEECC"> 
            <div align="center">%$refcde%</div>
          </td>
        </tr>
        <tr> 
          <td valign="middle" width="45%" bgcolor="#999999"> 
            <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">Responsable</font></b></div>
          </td>
          <td valign="middle" width="55%" bgcolor="#FFEECC"> 
            <div align="center">%$responsablecde%</div>
          </td>
        </tr>
      </table>
      <p>&nbsp;</p>
    </td>
  </tr>
</table>
<div align="center">
  <br>
</div>
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr> 
    <td width="14%" bgcolor="#999999"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Quantite</b></font></div>
    </td>
    <td width="40%" bgcolor="#999999"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Description</b></font></div>
    </td>
    <td width="18%" bgcolor="#999999"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>P.U.</b></font></div>
    </td>
    <td width="28%" bgcolor="#999999"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Montant</b></font></div>
    </td>
  </tr>
<!-- fin entete facture -->|;  
 

#entete d'un duplicata de facture
my $enteteDuplicata = q|
<!-- debut entete facture duplicata -->
<html>
<body bgcolor=#ffffff>
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr> 
    <td valign="top" width="54%"> 
      <img src="%$BASEADHTMLTHEME%/icones/%$logofacture%" width="150" height="52">
    </td>
    <td width="46%" valign="top"> 
      <table width="80%" border="0" cellspacing="0" cellpadding="0" align="right">
        <tr>
          <td width="68%"> 
            <div align="right"><b><font face="Arial, Helvetica, sans-serif" size="2">Facture 
              :&nbsp;&nbsp; </font></b></div>
          </td>
          <td width="32%" bgcolor="#FFEECC" height="30" align="center">%$numfact%</td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td valign="top" width="54%">
        %$coord1%
        <br>
        <img src="%$BASEADHTMLTHEME%/icones/duplicata.gif"  align="bottom" valign="bottom">           
	  </td>
    <td height="206" width="46%" valign="top"> 
      <table width="100%" border="0" cellspacing="1" cellpadding="2" height="121" bgcolor="#000000" align="left">
        <tr> 
          <td bgcolor="#FFEECC" valign="top">            
            <font face="Arial, Helvetica, sans-serif" size="2"><b>&nbsp;&nbsp;Adress&eacute; 
              &agrave; :</b></font><b><br>
              </b><center><b>
              <b><font face="Arial, Helvetica, sans-serif" size="2">
              %$clientnom% </font><br>
              <font face="Arial, Helvetica, sans-serif" size="2">
              %$clientnom2%<br>
              <font face="Arial, Helvetica, sans-serif" size="2">
              %$clienttitre%<br>
              </font></font></b><font face="Arial, Helvetica, sans-serif" size="2"><b><font face="Arial, Helvetica, sans-serif" size="2">%$clientrue1%<br>
              </font></b><b><font face="Arial, Helvetica, sans-serif" size="2">%$clientrue2%<br>
              </font></b><b><font face="Arial, Helvetica, sans-serif" size="2">%$clientcp% %$clientville%</font></b>
             <br></font></b><b><font face="Arial, Helvetica, sans-serif" size="2">%$clientpays%<br>
             </font></b></center>
            </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<hr width="100%">
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr> 
    <td valign="top" width="54%"> 
      <p>&nbsp;</p>
      </td>
    <td width="46%" valign="top"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="3"><b><font size="4">FACTURE 
        </font> </b> </font></div>
    </td>
  </tr>
  <tr> 
  <td valign="top" width="54%">&nbsp;</td>
    <td width="46%" valign="top"> <br>
      <table width="100%" border="0" height="70" align="left" cellpadding="0" cellspacing="0">
        <tr> 
          <td valign="middle" width="45%" bgcolor="#999999"> 
            <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">Date</font></b></div>
          </td>
          <td valign="middle" width="55%" bgcolor="#FFEECC"> 
            <div align="center">%$datefact%</div>
          </td>
        </tr>
        <tr> 
          <td valign="middle" width="45%" bgcolor="#999999"> 
            <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">R&eacute;f. 
              commande</font></b></div>
          </td>
          <td valign="middle" width="55%" bgcolor="#FFEECC"> 
            <div align="center">%$refcde%</div>
          </td>
        </tr>
        <tr> 
          <td valign="middle" width="45%" bgcolor="#999999"> 
            <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">Responsable</font></b></div>
          </td>
          <td valign="middle" width="55%" bgcolor="#FFEECC"> 
            <div align="center">%$responsablecde%</div>
          </td>
        </tr>
      </table>
      <p>&nbsp;</p>
    </td>
  </tr>
</table>
<div align="center">
  <br>
</div>
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr>
    <td width="14%" bgcolor="#999999"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Quantite</b></font></div>
    </td>
    <td width="40%" bgcolor="#999999"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Description</b></font></div>
    </td>
    <td width="18%" bgcolor="#999999"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>P.U.</b></font></div>
    </td>
    <td width="28%" bgcolor="#999999"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Montant</b></font></div>
    </td>
  </tr>  
<!-- fin entete duplicata -->|;  


#une ligne de facture  
my $ligfact = q|
<!-- debut une ligne de facture -->
  <tr> 
    <td bgcolor="#FFEECC" width="10%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2"> 
        %$qtefacture%</font></div>
    </td>
    <td bgcolor="#FFEECC" width="50%"> 
      <div align="center">%$libartic% </div>
    </td>
    <td bgcolor="#FFEECC" width="15%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2">
        %$prixHT% <img src="%$BASEADHTMLTHEME%/icones/%$symbolemonet%"></font></div>
    </td>
    <td bgcolor="#FFEECC" width="25%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2">%$mtht% 
         <img src="%$BASEADHTMLTHEME%/icones/%$symbolemonet%"></font></div>
    </td>
    
  </tr>
<!-- fin une ligne de facture -->|;

#suite ligne de facture  
my $ligfactsuite = q|
<!-- debut une ligne de facture -->
  <tr> 
    <td bgcolor="#FFEECC" width="14%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2"> 
        &nbsp;</font></div>
    </td>
    <td bgcolor="#FFEECC" width="40%"> 
      <div align="center">%$libartic% </div>
    </td>
    <td bgcolor="#FFEECC" width="18%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2"> 
        &nbsp; </font></div>
    </td>
    <td bgcolor="#FFEECC" width="28%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2">&nbsp;
         </font></div>
    </td>
    
  </tr>
<!-- fin suite ligne de facture -->|;


#ligne de report du haut pour les factures sur plusieurs pages
my $ligreport = q|
<!-- debut ligne report -->
  <tr> 
    <td bgcolor="#FFEECC" width="14%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2"> 
        &nbsp;</font></div>
    </td>
    <td bgcolor="#FFEECC" width="40%"> 
      <div align="center">REPORT TOTAL PAGE PRECEDENTE </div>
    </td>
    <td bgcolor="#FFEECC" width="18%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2"> 
       &nbsp;</font></div>
    </td>
    <td bgcolor="#FFEECC" width="28%"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2">
      %$reportbis%<img src="%$BASEADHTMLTHEME%/icones/%$symbolemonet%">
         </font></div>
    </td>
    
  </tr>
<!-- fin une ligne report -->|;


#quand le nombre de ligne d'une page est < $nbligfact
my $ligblanche = q|
<!-- debut ligne blanche de facture -->
  <tr> 
    <td bgcolor="#FFEECC" width="14%">&nbsp;</td>
    <td bgcolor="#FFEECC" width="40%">&nbsp;</td>       
    <td bgcolor="#FFEECC" width="18%">&nbsp;</td>      
    <td bgcolor="#FFEECC" width="28%">&nbsp;</td>       
  </tr>
<!-- fin une ligne blanche de facture -->|;


#total facture pour derniere page
my $totalmaqfact = q|
<!-- debut total facture -->
  <tr> 
    <td width="14%">&nbsp; </td>
    <td width="40%" valign="top">&nbsp; </td>
    <td bgcolor="#999999" width="18%" valign="top"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Total 
        HT</b></font></div>
    </td>
    <td bgcolor="#FFEECC" width="15%" valign="top"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2">%$totHT% 
         <img src="%$BASEADHTMLTHEME%/icones/%$symbolemonet%"></font></div>
    </td>    
  </tr>
  <tr> 
    <td width="14%"><font face="Arial, Helvetica, sans-serif" size="2"><b>Contact 
      : </b></font></td>
    <td width="40%" valign="top">%$contact%</td>
    <td bgcolor="#999999" width="18%" valign="top"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Frais 
        de livraison</b></font></div>
    </td>
    <td bgcolor="#FFEECC" width="15%" valign="top" align="center">
       <div align="center"><font face="Arial, Helvetica, sans-serif" size="2">%$fraisdeplt%
         <img src="%$BASEADHTMLTHEME%/icones/%$symbolemonet%"></font></div>
    </td>    
  </tr>
  <tr> 
    <td width="14%">&nbsp;</td>
    <td width="40%" valign="top"> 
      <div align="right"><font face="Arial, Helvetica, sans-serif" size="2">T.V.A.</font>&nbsp;</div>
    </td>
    <td bgcolor="#999999" width="18%" valign="top"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>%$tauxtva%%</b></font></div>
    </td>
    <td bgcolor="#FFEECC" width="15%" valign="top"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2">%$TVA% 
          <img src="%$BASEADHTMLTHEME%/icones/%$symbolemonet%"></font></div>
    </td>    
  </tr>
  <tr> 
    <td width="14%">&nbsp;</td>
    <td width="40%" valign="top">&nbsp;</td>
    <td bgcolor="#999999" width="18%" valign="top"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Total 
        T.T.C</b></font> </div>
    </td>
    <td bgcolor="#FFD98A" width="15%" valign="top"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2"><b>%$totTTC% 
        <img src="%$BASEADHTMLTHEME%/icones/%$symbolemonet%"></b> </font></div>
    </td> 
  </tr>
</table>
<div align="center">
  <br>
</div>
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr> 
    <td width="54%" rowspan="2"> 
      <table width="80%" border="0" cellspacing="2" cellpadding="2" bgcolor="#333333">
        <tr>          
            %$coord2%  
        </tr>
      </table>
    </td>
    <td width="46%"> 
      <div align="left"><font color="#000000" face="Arial, Helvetica, sans-serif" size="2">Informations 
        compl&eacute;mentaires</font></div>
    </td>
  </tr>
  <tr> 
    <td width="46%" valign="top"> 
      <div align="center">
        <table width="100%" border="0" height="70" align="left" cellpadding="0" cellspacing="0">
          <tr> 
            <td valign="middle" width="45%" bgcolor="#999999"> 
              <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">R&eacute;gl&eacute; 
                le :</font></b></div>
            </td>
            <td valign="middle" width="55%" bgcolor="#FFEECC" align="center">%$datereglement%</td>
          </tr>
          <tr> 
            <td valign="middle" width="45%" bgcolor="#999999"> 
              <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">Ch&egrave;que 
                n&deg; :</font></b></div>
            </td>
            <td valign="middle" width="55%" bgcolor="#FFEECC" align="center">%$numcheque%</td>
          </tr>
          <tr> 
            <td valign="middle" width="45%" bgcolor="#999999"> 
              <div align="center"><b><font face="Arial, Helvetica, sans-serif" size="2" color="#FFFFFF">Banque 
                :</font></b></div>
            </td>
            <td valign="middle" width="55%" bgcolor="#FFEECC" align="center">%$banquereglement%</td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
</table>   
<!-- fin total facture -->|;


#total de bas de page quand plusieurs pages pour pages non finales
my $totalreport = q|
<!-- debut report total HT facture -->
  <tr> 
    <td width="14%">&nbsp; </td>
    <td width="40%" valign="top">&nbsp; </td>
    <td bgcolor="#999999" width="18%" valign="top"> 
      <div align="center"><font color="#FFFFFF" face="Arial, Helvetica, sans-serif" size="2"><b>Total 
        HT  reporter</b></font></div>
    </td>
    <td bgcolor="#FFEECC" width="15%" valign="top"> 
      <div align="center"><font face="Arial, Helvetica, sans-serif" size="2">%$reportbis% 
      <img src="%$BASEADHTMLTHEME%/icones/euro2.gif"></font></div>
    </td> 
    <!-- pied facture -->
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr>
   <td>
       <font face="Arial, Helvetica, sans-serif" size="2"><b>Contact: </b></font>
   </td>
   <td>
       %$contact%
   </td>
  </tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
</table>
<!-- fin report total HT facture -->|;


#pied facture, dans tous les cas
my $pied = q|
<!-- debut pied -->
<div align="center"> 
  <p>
    <br>
  </p>
</div>
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr> 
    <td valign="top">
      %$ordre% 
      <b>Paiement d %$echeance% 
         la date de facturation<br>
        Majoration de 10% par mois de dcalage de paiement<br>
        </b></font></p>
      <hr>
      <font face="Arial, Helvetica, sans-serif" size="2"><b> </b> </font>
<p align="center"><font face="Arial, Helvetica, sans-serif" size="2"><b>%$coordbasfact%</b></font></p>
    </td>
  </tr>
</table>
<body>
</html>
<!-- fin pied -->|;

my $factsanslig = q|
 <html>
  <body>
   <center>
	   <p>pas de ligne de facture pour la facture %$numfact%</p>
   </center>
  </body>
 </html>|;

sub editfact{
	my ($numfact,$refenteteFacture,$reftab,$tauxtva,$login,$type,$idmod) = @_;
	if($numfact){
		&editionfacture($numfact,$refenteteFacture,$reftab,$tauxtva);
	}
#=pod
	else{#facture existe pas
	        my $script = "facture";
		$rafraichirEcran =~ s/%(\$\w+)%/$1/gee;
		print header();
		print $rafraichirEcran;
	}
#=cut
}
sub editionfacture{
	my ($numfact,$refenteteFacture,$reftab,$tauxtva) = @_;
	my @tab = @$reftab;
	
	#recup valeurs d'entete	
	my ($clientnom, $responsablecde, $datefact, $refcde, $clientrue1, $clientville,
    $clientcp, $datereglement, $totHT, $totTTC, $fraisdeplt, 
    $banquereglement, $numcheque, $contact, $clientnom2, $clientrue2,
    $clienttitre, $clientpays,$echeance) = @$refenteteFacture;
    my $TVA = $totTTC - $totHT - $fraisdeplt;
    foreach my $elem ( $totHT, $totTTC, $fraisdeplt,$TVA){
    	$elem = &formatNombre($elem);
	}
	$datefact = join("/",&sec_calend($datefact));
	if($datereglement){
		$datereglement = join("/",&sec_calend($datereglement));
	}
	else{$datereglement = "&nbsp;";}
    if($echeance != -1){
		$echeance = "dans&nbsp;les&nbsp;$dateech{$echeance}";
	}
	else{$echeance = '';}
	foreach my $val ($numcheque,$refcde,$banquereglement){
		if (!$val){$val ="&nbsp;";}
	} 
	
    #construction de la page    
    
    my $entete = param('edit')? $enteteFacture:$enteteDuplicata; 
    $entete =~ s/%(\$\w+)%/$1/gee;    
    $totalmaqfact =~ s/%(\$\w+)%/$1/gee;
    $pied =~ s/%(\$\w+)%/$1/gee;
    
    #############################
    #on gere l'affichage facture
    #############################    

    my $i=0;
    my @pages =();
    my $report=0;    
	my $reportbis = '';
	#on genere une page par facture de 12 lignes
    while( $i< @tab){
       my $j=0; my @affichage = ();
       my $fich="$BASEADHTML/temp/page$i";
       open(DESC,">$fich") or 
         &alert("impossible d'ouvrir en ecriture $fich car $!");
	   print DESC $entete;
	   #si pas 1ere page, on met le report
	   if($report){
	      (my $lig = $ligreport) =~ s/%(\$\w+)%/$1/gee;
	      print DESC $lig;
	      $j++;#pour compter la ligne report dans le nb de lignes de factures 
	   }
	   my $continue = 1;		
	   while($i< @tab && $continue){
		   my($qtefacture, $libartic, $prixHT, $tauxTVA)=@{$tab[$i]};
		   #pour les lignes de plus de $maxcar
		   my $libarticsuite = ''; #prend les car apres le $maxcar
		   my @lig = (); #pour stocker la ligne
		   my $z = 0;					
		   my $mtht=$qtefacture*$prixHT;		
		   my $mtttc=$mtht*(1+$tauxTVA);		
		   $mtttc=sprintf("%.2f",$mtttc);
		   $mtht=sprintf("%.2f",$mtht); 
		   my $prixHTrep = $prixHT = sprintf("%.2f",$prixHT);
		   #$report +=$prixHT;
		   if($qtefacture<1){
			  $qtefacture=$qtefacture*100;
			  $qtefacture.="%";
		   }
		   
		   #formatage des prix pour l'affichage
		   foreach my $val($mtttc,$mtht,$prixHT){
		   	$val = &formatNombre($val);
		   }
		   ($libartic,$libarticsuite) = $libartic =~ /^(.{0,$maxcar})(.*)$/;
		   (my $ligne = $ligfact) =~ s/%(\$\w+)%/$1/gee;
		   push(@lig,$ligne);		   
		   $z++;
		   #on fractionne la ligne si le libelle a plus de $maxcar	 
		   while($libarticsuite){ 
		        ($libartic,$libarticsuite) = $libarticsuite =~ /^(.{0,$maxcar})(.*)$/;
		        (my $ligne = $ligfactsuite) =~ s/%(\$\w+)%/$1/gee;
		        push(@lig,$ligne);
		        $z++;
		   }		   
		   #si le total nb de lignes 
		   if($j + $z <= $nbligfact){
		      $j += $z;
		      $report +=$prixHTrep;
		      push(@affichage,@lig);
		      $i++;
		   } 
		   else{$continue = 0;}		   		       			
	   }
	   #$j=$nbligfact ou plus de lignes	
	   
	   while($j< $nbligfact){		    	
		   push(@affichage,$ligblanche);
		   $j++;
	   }
	   print DESC @affichage;
	   #on est en derniere page de facture	
	   if($i==@tab){
	     print DESC $totalmaqfact;	    
	   }
	   else{#c'est un page intermediaire
	      $reportbis = &formatNombre($report);	      
	      (my $totreport = $totalreport) =~ s/%(\$\w+)%/$1/gee;
	      print DESC $totreport;	      
	   }
	   print DESC $pied;
	   close(DESC);push(@pages,$fich);		
   }#fin  while
	

   #si pas de ligne de facture, message d'erreur
   if(!$i){
       open(DESC,">$BASEADHTML/temp/page");
       $factsanslig =~ s/%(\$\w+)%/$1/gee;	
	   print DESC $factsanslig;
	   close(DESC);push(@pages,"$BASEADHTML/temp/page");	
   }
 
=pod  
   print header();
   foreach my $page (@pages){
       open(PAGE,$page);
       my @pa = <PAGE>;
       close(PAGE);
       print @pa;
   }
=cut
#=pod

   #transformation au format pdf		
   select(STDOUT); $| = 1;
   print "Content-Type: application/pdf\n\n";
   # Run HTMLDOC to provide the PDF file to the user.. 
   system "$HTMLDOC -t pdf --quiet --webpage --no-title --textfont helvetica  --left 20 --bottom 0 --top 0 --fontsize 9.0 @pages";
   unlink(@pages); 
#=cut 
   return;	
}


1;

END{}
