#!/usr/bin/perl -w

BEGIN {
  unshift @INC, '../lib', '../html';
}

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
#use DBI;
use Conf;
use Util;



#creation d'un fichier de rapport
open(MAJ,">majrelance.txt");


#changement des statuts : 1(ancien non regle) => 2(ancien regle) et 2(ancien regle) => 1(ancien non regle)
my @liste = &listenum("numfact","facture","numfact >= 1","numfact");
foreach my $numfact (@liste){
	#$listechamps,$table,$cond)
	my $statutmaj = 0;
	my ($statut) = &select_une_lig("statutfact","facture","numfact = $numfact");
	if($statut == 1){$statutmaj = 2;}
	elsif ($statut == 2){$statutmaj = 1;}
	if($statutmaj){&maj("numfact = $numfact",{"statutfact" => $statutmaj},"facture");}
}


#recherche et suppression de toutes les relances sans factures associes
#liste des relances
@liste = &listenum("numfact","relance","idrelance > 0 ","numfact");
#chercher les numfact dans relances qui existent pas dans facture
my @listefacture = ();
foreach my $num (@liste){
	my @tab = ();
	if(!(@tab=&select_une_lig("numfact","facture","numfact = $num"))){
	   push(@listefacture,$num);
	}
}

if(@listefacture){
  my $listefacture = join(', ',@listefacture);
  print MAJ " Les factures  $listefacture n'existe pas. Pourtant des enregistrement de relances existent\n";
  my $cond = " numfact in ($listefacture)";
  #suppression de ces relances
  &supp($cond,"relance");
  print MAJ "Ces enregistrements ont t supprims\n\n";
}


#suppression des relances associes  des factures de statut =2
#recherche des factures de statut = 2
@liste = &listenum("numfact","facture"," statutfact = 2 ","numfact");
my $liste = join(', ', @liste);

print MAJ "voici la liste des factures de statut = 2\n";
print MAJ "$liste\n";


foreach my $num (@liste){
	&supp("numfact = $num", "relance");
}
print MAJ "les enregistrement de relances associes ont t supprimes\n\n";



#mise  NR (2) les factures dont le statut est > 3 et qui n'ont pas de relances associes
@liste = &listenum("numfact","facture"," statutfact > 2 ","numfact");
my @listemodif = ();
foreach my $num (@liste){
	if(!(my $nb = &compte("idrelance","relance","numfact = $num"))){
		&maj("numfact = $num",{"statutfact" => 2}, "facture");
        push(@listemodif, $num);
	}
}
$liste = join(', ',@listemodif);
print MAJ "les factures suivantes :\n $liste\n ont un statut de relance mais n'ont de relances associes\n";
print MAJ  "le statut de ces factures a t mis  non rgl\n\n";


#verif et maj corralation statut relance, nb enreg relance
#normalement, statut = 2 + nbenregrelance
@liste = &listenum("numfact","facture"," statutfact > 2 ","numfact");
foreach my $num (@liste){
	my $statut = &compte("idrelance","relance","numfact = $num") + 2 ;
    &maj("numfact = $num",{"statutfact" =>  $statut}, "facture");
}
$liste = join(', ',@liste);
print MAJ "la verification de la correlation ainsi que la correction\n";
print MAJ " statut_relance/nombre enregistrement de relance a t faite pour les factures :\n";
print MAJ "$liste\n";



