=pod

package de variables pour les client
propres au theme UNGI

=cut

package UNGI::Client;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&majClient);	
		
}

use vars  @EXPORT;



##########################
#creer un client
##########################

my $creerClient = q|
<!-- Restricted-to: anybody -->
<!-- debut  $creerClient -->
	<form method="post" action="%$CGIADR%/client.cgi">
	<table width="600" cellpadding="3" cellspacing="1">
	  <tr >
	  	<td class="ligne2" width="20%">* %$name% :&nbsp;&nbsp;</td>	  	
	  	<td class="ligne2">	
	  		<input name="clientnomajout" type="text" value="%$para{clientnomajout}%" size="50">
	  	</td>
	  </tr>	  
	  <tr>	  
	  	<td class="ligne1"> %$name2% :&nbsp;&nbsp;</td>
	  	<td class="ligne1">	  	
	  		<input name="clientnom2ajout" type="text" value="%$para{clientnom2ajout}%" size="50">
	  	</td>
	  </tr>	  
	  <tr>
	  	<td class="ligne1">%$qualification% :&nbsp;&nbsp;</td>
	  	<td class="ligne1">
	  		<input name="clienttitreajout" type="text" value="%$para{clienttitreajout}%" size="50">
	  	</td>
	  </tr>  
	  <tr>
	  	<td class="ligne2" colspan="2">%$adress%</td>
	  </tr>  
	  <tr>
	  	<td class="ligne1">* %$street% :</td>
	  	<td class="ligne1">
	  		<input name="clientrue1ajout" type="text" value="%$para{clientrue1ajout}%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne2"> %$addresscomplement% :&nbsp;&nbsp</td>
	  	<td class="ligne2">
	  		<input name="clientrue2ajout" type="text" value="%$para{clientrue2ajout}%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne1">* %$city% :&nbsp;&nbsp</td>
	  	<td class="ligne1">
	  	   <input name="clientvilleajout" type="text" value="%$para{clientvilleajout}%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne2">* %$postal% :&nbsp;&nbsp</td> 	
	  	<td class="ligne2">
	  		<input name="clientcpajout" type="text" value="%$para{clientcpajout}%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne1">%$telephone% :&nbsp;&nbsp</td>
	  	<td class="ligne1">
	  		<input name="tel1ajout" type="text" value="%$para{tel1ajout}%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne2">%$telephone2% :&nbsp;&nbsp</td>
	  	<td class="ligne2">
	  		<input name="tel2ajout" type="text" value="%$para{tel2ajout}%" size="50">
	  	</td>
	  </tr>
          <tr>
	  	<td class="ligne1">%$telecopie% :&nbsp;&nbsp</td>
	  	<td class="ligne1">
	  		<input name="faxajout" type="text" value="%$para{faxajout}%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne2">%$e_mail% :&nbsp;&nbsp</td>
	  	<td class="ligne2">
	  		<input name="emailajout" type="text" value="%$para{emailajout}%" size="50">
	  	</td>
	  </tr>
	  <tr>	  
	  	<td class="ligne1"> %$country% :&nbsp;&nbsp</td>
	  	<td class="ligne1">
	  		<input name="clientpaysajout" type="text" value="%$para{clientpaysajout}%" size="50">
	  	</td>
	  </tr>	  
	 </table>	 
	 <input type="hidden" name="usertype" value="%$type%">
 	<input type="hidden" name="username" value="%$login%">
 	<input type="hidden" name="script" value="%$script%">
 	<input type="hidden" name="boutonnavig" value="%$boutonnavig%">
     %$champscache% 	
 	<table>	 	
 		<tr> 
 		  <td> 
 			<input name="validcrecli" type="image" border="0" src="%$HTMLADRUNGI%/icones/valider.gif">
 		  </td>
		  <td class="texterouge">%$messcrerclient%</td>	 	
 		</tr>
 	</table>
	</form>
<table>	
 	<tr>
 	    <td valign="middle">
 			<a href="%$CGIADR%/%$script%.cgi?usertype=%$type%&username=%$login%&%$ch%"><img border="0"  src="%$HTMLADRUNGI%/icones/abandonner.gif"></a>
 		</td> 		
 	</tr>	
</table>
<!-- fin  $creerClient -->|;

my $modifClient = q|
<!-- Restricted-to: anybody -->
<!-- debut  $modifClient -->
    <table width="600" class="ligne3">
	  <tr>
	  	<td class="texte4">%$idclient% :&nbsp;&nbsp;</td>
	  	<td class="textegras"> %%$clientid%%</td>	  	  	
	  </tr>
    </table>
	<form method="post" action="%$CGIADR%/client.cgi">
	<table width="500" cellpadding="3" cellspacing="1">
	  <tr >
	  	<td class="ligne2" width="20%">* %$name% :&nbsp;&nbsp;</td>	  	
	  	<td class="ligne2">	
	  		<input name="clientnomajout" type="text" value="%%$clientnom%%" size="50">
	  	</td>
	  </tr>	  
	  <tr>	  
	  	<td class="ligne1"> %$name2% :&nbsp;&nbsp;</td>
	  	<td class="ligne1">	  	
	  		<input name="clientnom2ajout" type="text" value="%%$clientnom2%%" size="50">
	  	</td>
	  </tr>	  
	  <tr>
	  	<td class="ligne1">%$qualification% :&nbsp;&nbsp;</td>
	  	<td class="ligne1">
	  		<input name="clienttitreajout" type="text" value="%%$clienttitre%%" size="50">
	  	</td>
	  </tr>  
	  <tr>
	  	<td class="ligne2" colspan="2">%$adress%</td>
	  </tr>  
	  <tr>
	  	<td class="ligne1">* %$street% :</td>
	  	<td class="ligne1">
	  		<input name="clientrue1ajout" type="text" value="%%$clientrue1%%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne2"> %$addresscomplement% :&nbsp;&nbsp</td>
	  	<td class="ligne2">
	  		<input name="clientrue2ajout" type="text" value="%%$clientrue2%%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne1">* %$city% :&nbsp;&nbsp</td>
	  	<td class="ligne1">
	  	   <input name="clientvilleajout" type="text" value="%%$clientville%%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne2">* %$postal% :&nbsp;&nbsp</td> 	
	  	<td class="ligne2">
	  		<input name="clientcpajout" type="text" value="%%$clientcp%%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne1">%$telephone% :&nbsp;&nbsp</td>
	  	<td class="ligne1">
	  		<input name="tel1ajout" type="text" value="%%$tel1%%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne2">%$telephone2% :&nbsp;&nbsp</td>
	  	<td class="ligne2">
	  		<input name="tel2ajout" type="text" value="%%$tel2%%" size="50">
	  	</td>
	  </tr>
          <tr>
	  	<td class="ligne1">%$telecopie% :&nbsp;&nbsp</td>
	  	<td class="ligne1">
	  		<input name="faxajout" type="text" value="%%$fax%%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne2">%$e_mail% :&nbsp;&nbsp</td>
	  	<td class="ligne2">
	  		<input name="emailajout" type="text" value="%%$email%%" size="50">
	  	</td>
	  </tr>
	  <tr>	  
	  	<td class="ligne1"> %$country% :&nbsp;&nbsp</td>
	  	<td class="ligne1">
	  		<input name="clientpaysajout" type="text" value="%%$clientpays%%" size="50">
	  	</td>
	  </tr>	  
	 </table>	 
	 <input type="hidden" name="usertype" value="%$type%">
 	<input type="hidden" name="username" value="%$login%">
 	<input type="hidden" name="clientid" value="%$clientid%">
 	<input type="hidden" name="script" value="%$script%">
 	<input type="hidden" name="boutonnavig" value="%$boutonnavig%">
     %$champscache% 	
 	<table>	 	
 		<tr> 
 		  <td> 
 			<input name="validmodcli" type="image" border="0" src="%$HTMLADRUNGI%/icones/valider.gif">
 		  </td>
		  <td class="texterouge">%$messmodclient%</td>	 	
 		</tr>
 	</table>
	</form>
<table>	
 	<tr>
 	    <td valign="middle">
 			<a href="%$CGIADR%/%$script%.cgi?usertype=%$type%&username=%$login%&%$ch%"><img border="0"  src="%$HTMLADRUNGI%/icones/retour.gif"></a>
 		</td> 		
 	</tr>	
</table>
<!-- fin  $modifClient -->|;



=head2 majClient

appel la fonction de creation ou maj d'un client

=cut

sub majClient{
	my($clientid,$type,$login,$title,$script,$boutonnavig,$refpara,$refenregclient,$mess) = @_;	
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);	
	my %para = %$refpara;	
	my $champscache = &getHidden(%para);
	if(exists $para{"toupdate"}){
	   $champscache .= &AffichLig($hidden,"toupdate",$para{"toupdate"});
	   $ch .= "&toupdate=$para{toupdate}";
	}			
    my $page=$body.&AffichLig(&affiche_barre($type,\%navigation,$boutonnavig),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}	
	if($clientid){		
		$page .= &ModifierClient($clientid,$refenregclient,\%para);		
	}
	else{$page .= &CreerClient(\%para);}		
	$page =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb($title,$page);
	return;
} 

#creer un client
sub CreerClient{	
	my ($refpara) = @_;
	my %para = %$refpara;				
    my $page .=$creerClient; 
    $page =~ s/%(\$\w+\{\w+\})%/$1/gee;     
    $page  =~ s/%%(\$\w+)%%/$1/gee;  
    return $page;
}

#modifier un client
sub ModifierClient{	 
	my ($clientid,$refenregclient,$refpara)=@_;
	my %para = %$refpara;	
	#recup valeurs entete
	my ($clientnom,$clientnom2,$clientrue1,$clientrue2,$clientville,$clientcp,$email,
    $tel1,$tel2, $clienttitre,$clientpays,$fax)=@$refenregclient;
	my $page .=$modifClient;	
	#pour ajouter une ligne de facture
	$page =~ s/%%(\$\w+)%%/$1/gee;
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;	 
	#sub sur %% pour substituer seulement les valeurs passees,
	#sinon substitue les valeurs non passees par ''!
	          
    return $page;
}

1;

END{}
