#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####

=pod
	variables de connection et constante
=cut
package Conf;
use strict;

BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw($HTMLADRESSE   $BASEAD $LIBAD $HTMLDOC
	 $conscde $CGIADR
	 $CONNECTBDD $USERBDD $MDPBDD  $tvaconst  $euro $mail $nblig
	 $constbank $BASEADHTML  $scriptdepart $nbligstat  $nbligfact 
	 $defaultpayment
	  @barrehautdroit $customer $root  
	  $BASEADHTMLTHEME $HTMLADRUNGI 
	  $logofacture $coord1 $coord2 $coordhautfax $coordbasfax $coordbasfact
	  $ordre $moiscomptable $symbolemonet
	  $maxrelance $maxrelancefax $maxcar $pourcretard $signature);	
}

use vars   @EXPORT;

##############################################
#variables serveur  configurer absolument
##############################################

#$CONNECTBDD est la variable de connection  la base de donne
#remplacer 'host_name' par l'adresse de la machine o tourne le serveur MySQL
 $CONNECTBDD = "dbi:mysql:FACTURIER:localhost";


 
#$USERBDD  pour valeur le login d'un utilisateur pouvant se connecter
# la base de donne  'FACTURIER' sur le serveur MySQL 
 #remplacer 'PROP_BD' par le login d'un utilisateur ayant le droit d'utiliser
 #la base de donne 'facturier' sur le serveur MySQL
 $USERBDD="PROP_BD";
 
 
 #$MDPBDD contient la valeur du mot de passe de connection de l'utilisateur
 #$USERBDD au serveur MySQL
 #remplacer 'MDP_BD' par le mot de passe du login de l'utilisateur
 #ci-dessus
 $MDPBDD="MDP_BD";
 
 
 #$CGIADR contient la valeur du scriptalias pour le 'Facturier' sur le serveur web 
 #remplacer 'scriptalias' par le scriptalias du 'Facturier'
 #si scriptalias = fact alors 
 $CGIADR="/fact";

 
 
 #$BASEAD contient le chemin absolu du rpertoire facturier sur le serveur 
 # o est install le 'Facturier'
 #remplacer 'chemin repertoire principale (facturier/)' par le chemin du repertoire
 #facturier : si le facturier est dans /var/www/html, alors :
 $BASEAD ="/usr/local/www/facturier/";

 
 
 #$HTMLDOC contient le chemin de la commande htmldoc
 #si la commande htmldoc que vous dsirez utiliser est dans "/usr/bin/" faire
 $HTMLDOC="/usr/local/bin/htmldoc";

 #$HTMLADRESSE indique au serveur web o se trouve les pages html utilises par le facturier
 # par apport au DocumentRoot. Si vous avez install le facturier dans le DocumentRoot
 #vous n'aurez pas besoin de modifier la valeur de $HTMLADRESSE
 $HTMLADRESSE='/../facturier/html';
 
###################################
#finvariables serveur  configurer
##################################

#$BASEADHTML contient le chemin du repertoire html du rpertoire facturier sur le serveur
 $BASEADHTML="$BASEAD/html";
#chemin absolu des pages html propres au themes UNGI
 $BASEADHTMLTHEME= "$BASEADHTML/UNGI";
 
#$LIBAD contient le chemin du repertoire lib du facturier sur le serveur
 $LIBAD="$BASEAD/lib";

#$HTMLADRUNGI indique au serveur web o trouver les pages html propres au theme UNGI
 $HTMLADRUNGI = "$HTMLADRESSE/UNGI";
 
 #$mail contient l'adresse email  laquelle envoy un message lors de la cration
 #d'un commande (cf manuel utilisateur) si on le dsire.
 #Mettre un '\' avant @, par ex : $mail='patron\@adr.net';
 #si l'adresse email est : "patron@adr.net 
 $mail="";
 
 #script de depart : module sur lequel dmarrer une fois la connection effectue
 #liste des factures par dfaut
 $scriptdepart = "facture"; 
 
 #taux de tva
 $tvaconst="19.60";
 
 #valeur d'un euro en franc
 $euro=6.55957; 
 
 #nombre de lignes d'occurrence d'un objet (factures, dpenses, ...) affiches
 #par dfaut par cran
 $nblig = 12;
 
 #nombre de lignes statistiques affiches  par dfaut dans la liste des statistiques
 $nbligstat=12;
 
 #nombre de lignes par facture dite
 $nbligfact=14;
 
 #valeur du compte en banque de l'entreprise avant que vous ne crer votre 1re facture
 #ou dpense avec le 'Facturier'
 $constbank=0; 
 
 #mois depart annee comptable (1 = janvier, 12 = dcembre)
 $moiscomptable = 9;

 #chance de paiement en jours avec laquelle une facture est cre par dfaut, ici 30 pour 30 jours.
 $defaultpayment = 30;

 #le seul utilisateur que l'on ne peut pas supprimer
 $root = 'admin';
 
 #sert  forcer  choisir un client dans la liste des noms de client
 #quand on cre un utilisateur de type 'client'
 $customer = "client"; 
 
 #pour l'edition de facture et des relances
 #logo facture, lettre et fax de relance
 $logofacture = "log_facture.gif";
 #symbole monetaire d'un facture
 $symbolemonet = "euro2.gif";
 #coord lettre de relance et facture
 $coord1 = q|<font face="Arial, Helvetica, sans-serif" size="2"><br><b>Sige Social <font class=font5>:</font></b>
        2, rue de la Piscine - 75021 Paris <br>
        <b>Adresse de correspondance :</b> <br>
        2 rue de la Piscine- 75021 Paris <br>
        <b>Tl :</b> 01 01 01 01 <br>
      <b>E-mail :</b> <a href="mail@mail">mail@mail</a></font>|;

#coord bas de facture
$coord2 = q|<td bgcolor="#FFFFFF"><font face="Arial, Helvetica, sans-serif" size="2" class="font5"><b>Compte 
            :</b> PISCINE S.A.<br>
            <b>Domiciliation :</b> PISCINE<br>
            <b>Code Banque :</b> 0000<br>
            <b>Code Guichet :</b> 0000<br>
            <b>Cl&eacute; RIB :</b> 00</font></td>|;

$ordre = q|<p><font face="Arial, Helvetica, sans-serif" size="2"><i>Rglement par chque 
         l'ordre de <b>NEANT<span style="mso-spacerun: yes"></span>SA</b></i></font><i><font class="font2" face="Arial, Helvetica, sans-serif" size="2">
        ou par virement au compte mentionn ci-dessus</font></i><font face="Arial, Helvetica, sans-serif" size="2"><br>|;

$coordbasfact = q|NEANT  000 000(000000) SIRET 000000000000|;

#coord haut de fax de relance
$coordhautfax = q|
            NEANT<br>la Piscine<br>
            75021 PARIS<br>
            TEl : 01 01 01 01 01 <br>
|;

#coord bas de fax de relance
$coordbasfax = q|
            <b><font size="2">Socit NEANT Paris - tel : 01 01 01
            01 01 - Fax : 01 01 01 01 01</font></b>
|;

$signature = "Facturier";

#maximum de relance pour une facture
$maxrelance = 3;
#pour le nombre de lettre de relance au format fax
$maxrelancefax = 2;
#nb de car max par ligne de facture pour le libelle
$maxcar = 50;
#pourcentage d'indemnite par mois de retard de paiement d'une facture
$pourcretard = 0.10;
 
 1;
 
 END{}
