#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####

=pod
        package de variable globale utiliss pour l'affichage
=cut
package lang::Fr;
use strict;
use Tie::IxHash;

BEGIN{
        use Exporter;
        use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);
        $VERSION = 1.00;
        @ISA = qw(Exporter);
        @EXPORT= qw(
        $messqtelig $messtva $messprixlig $messlibexiste $messajoutok $messmodok $messretourentree
        $messfact $messfraisdeplt $messajout $messlib $messajoutcliok $messreglement
        $messresp $messdatefact $messmod $messcreatok $messmodifok $messmodcliok $messedit
        $messdatereglement $messdatedep $messttc $messht $messajdepok $messprice $messdateorder
        $messorderref $messname $messajcdeok $messlogin $messmdp $messnelog $messlogexiste
        $messmdpexiste $messnoselect $messcalculation $messnocomment $messchoicecustomer
        $messnocustomerselect $messnoestimselect $messdatepropal $messuserupdate
        $messnocliandtypecli $messcreatuserok $messnotwholename $messnameroleexist
        $messnomcomproleexist $messmodifuserok $messdateprevision $messligsuppok
        $messmoddepok $messfactsupp $messcrerclient $messcliexiste $messmodclient
        $messnomclinotok $messrueclinotok $messvilleclinotok $messcpclinotok
        $messajpropalok $messmodpropalok $messsupppropalok $messchoiceecheance
        $messmodcdeok $messmodsuppok $messcreatfact $messchoicestatut $messnostatutselect
        $messinvalidstatut $messmodentetefact $messretourlistefact $messretpropal
        $messnoselectpayment $messnoecheance $messpropalverscde $messdateregandnotset
        $messsetandnotdatereg $messusersuppok $messretdep $messretcde $messchoicepaiment
	$messrensregnotok $messrafecran
        $title $titleconsfact $titlecli $titlemodfact $titleconsentree $titlereglerfact
        $titleconsdep $titleconscde $titlemoduser $titlecomplement $titleconspropal
        $titleuser $titleconnect $titlecreatclient $titleCreatExpense $titleModExpense
        $titleCreatOrder  $titleModOrder $titleModPropal $titleCreatPropal $titleConsStat
        $titleConsRelance $titlepropverscde
        $searchby $sortby $addligfact $adddep $addorder $addpropal
        $errorconnect $notokopen  $errorprepare $errorexecute
        $date $day $month $year $billdate $regulationdate $expensedate $orderdate %hashmonth   $datefacturation
        $factureplusanc  $datelastrevival $propaldate $dateprevision
          $idcheque $bank $pricemovement  $turnover
        $totalwithouttax $totalwithtax $modepaiement
        $unitprice $tva $sum $totalwithouttaxsort $totalwithtaxsort $total $totalsort $nocheque
        $expense $profit $regulation $average   $countrevival
        $qualification  $passwd $name2  $responsable $contactfact $nobody
        $namecommercial $nameleadproject $namecli $idclient $mansupply $iduser $idusersort
        $loginname $role $rolesort $wholename $name $customername
        $adress $street $city $postal $adress2 $adress3 $country $clientpostal $state
        $addresscomplement $telephone $telephone2 $e_mail
        $idbill $id $idorder  $bill $orderreference $idbillliste $idsort $orderreferencesort
        $idordersort  $idpropalsort $idexpense
        $linenumber  $quantity  $ontotal $quantity $percentage $propalestim
        $action  $all $nosupply  $wording $wordsort  $confirmpassword
        $oldpassword $newpassword $select
        $commentaires %propal $selectpropalestim $giveorderref
        %dateech $datepayment $selectpayment  $dayspayment $payment $dpayment
        $billstatus $billsend %modepaiement
        $boamp $chefprojetencours $telecopie);


}

use vars   @EXPORT;

#message utilisateur avertissement
$messqtelig="Quantit&eacute; non valide ";
$messtva = "TVA non valide ";
$messprixlig = "Prix non valide ";
$messttc="Prix TTC non valide ";
$messht="Prix HT non valide ";
$messprice="Prix non valide ";
$messlibexiste="Le libell&eacute; existe d&eacute;j&agrave; ";
$messajoutok =" Ligne ajout&eacute;e";
$messligsuppok = "Ligne supprim&eacute;e";
$messajdepok="D&eacute;pense ajout&eacute;e";
$messretdep = "Cliquer ici pour retourner &agrave; la liste des d&eacute;penses";
$messmoddepok = "D&eacute;pense modifi&eacute;e";
$messmodok="Ligne modifi&eacute;";
$messmodentetefact = "Cliquez ici pour enregistrer les modifications de l'entte";
$messfact = "Cliquer ici pour valider ";
$messcreatfact = "Cliquer ici pour continuer la cr&eacute;ation en ajoutant des lignes de facturation ";
$messresp = "Responsable non renseign&eacute;";
$messdatefact = "Date de facture non valide";
$messdateorder="Date de commande non valide";
$messdateprevision = "Date de facture pr&eacute;visionnelle non valide";
$messdatereglement="Date de r&egrave;glement non valide";
$messdatedep="Date de d&eacute;pense non valide";
$messfraisdeplt="Frais de livraison non valides";
$messcreatok="Facture cr&eacute;e";
$messcreatuserok ="Utilisateur cr&eacute;&eacute;";
$messmodifok="Modification de la facture enregistr&eacute;e";
$messfactsupp = "Facture supprim&eacute;e";
$messretourlistefact = " &agrave; la liste des factures";
$messmodifuserok="Modification de l'utilisateur enregistr&eacute;e";
$messajout = "Cliquer ici pour ajouter ";
$messmod="Cliquer ici pour valider";
$messuserupdate = q|Utilisateur %$username% modifi&eacute;|;
$messusersuppok = "utilisateur supprim&Eacute;";
$messlib = "Libell&eacute; non renseign&eacute;";
$messcrerclient = "Cliquez ici pour cr&eacute;er le client";
$messmodclient = "Cliquez ici pour modifier le client";
$messajoutcliok="client ajout&eacute;";
$messmodcliok="client modifi&eacute;";
$messnomclinotok = "Nom du client non renseign&eacute;";
$messrueclinotok = "Rue non renseign&eacute;";
$messvilleclinotok = "Ville non renseign&eacute;";
$messcpclinotok="Code postal non renseign&eacute;";
$messcliexiste = "Ce client existe d&eacute;j&agrave";
$messreglement="Cliquer ici pour enregistrer le  r&eacute;glement";
$messretourentree="Cliquer ici pour retourner &agrave; la liste des entr&eacute;es";
$messedit="Cliquer ici pour &eacute;diter la facture";
$messorderref="R&eacute;f&eacute;rence commande non renseign&eacute;e";
$messname="Nom non renseign&eacute;";
$messajcdeok ="Commande ajout&eacute;e";
$messretcde ="Cliquer ici pour retourner &agrave; la liste des commandes";
$messmodcdeok ="Commande modifi&eacute;e";
$messmodsuppok = "Commande supprim&eacute;e";
$messlogin="Login non renseign&eacute;";
$messmdp="Mot de passe incorrect";
$messnelog="Ancien mot de passe incorrect";
$messnotwholename = "Pas de nom complet";
$messlogexiste="Ce login existe d&eacute;j&agrave;";
$messnameroleexist = "Un utilisateur a dj ce nom et ce rle";
$messnomcomproleexist = "Un utilisateur a dj ce nom complet et ce rle";
$messnocliandtypecli = "Type client sans nom de client";
$messmdpexiste="Le mot de passe existe d&eacute;j&agrave;";
$messnoselect="Pas de lignes s&eacute;lectionn&eacute;es";
$messcalculation="Calcul automatique du HT  partir du TTC ou du TTC  partir du HT en cochant la case ci-dessous";
$messnocomment="pas de commentaires associs  la commande n ";
$messchoicecustomer="Slectionnez un client";
$messchoicestatut="Slectionnez un statut";
$messnocustomerselect = "Pas de client s&eacute;lectionn&eacute;";
$messnostatutselect = "Pas de statut s&eacute;lectionn&eacute;";
$messinvalidstatut = "Statut invalide";
$messnoestimselect = "Pas d'estimation s&eacute;lectionn&eacute;e";
$messdatepropal = "Date de proposition non valide";
$messnoselectpayment = "Pas d'&eacute;ch&eacute;ance s&eacute;lectionn&eacute;e";
$messajpropalok = "Proposition ajout&eacute;e";
$messmodpropalok = "Proposition modif&eacute;e";
$messsupppropalok = "Proposition supprim&eacute;e";
$messchoiceecheance = "Slectionnez une chance";
$messnoecheance = "Pas d'&eacute;ch&eacute;ance";
$messchoicepaiment = "Choisissez le mode de paiement";
$messretpropal = "Cliquer ici pour revenir &agrave; la liste des propositions";
$messdateregandnotset ="Date de rglement avec statut : non rgl";
$messsetandnotdatereg = "Statut rgl sans date de rglement";
$messrensregnotok = "Les 3 champs concernant le r&egrave;glement doivent &Ecirc;tre correctement renseign&eacute;s";
$messpropalverscde = q|Pour transformer la proposition %$idpropal% en commande vous devez : <br>
                        1) Choisir le client dans la liste "%$namecli%". S'il n'existe pas
                        dans cette liste, cr&eacute;ez-le &agrave; l'aide du bouton
                        "Cr&eacute;er le client",<br>
                        2) Entrez la r&eacute;f&eacute;rence de la commande dans la zone "%$orderreference%"|;

$messrafecran = q|L\'entit&eacute; que vous avez s&eacute;lectionn&eacute;e n\'existe plus|;

# titre pages html
$titleconnect = "Connexion";
$titleconsfact= "Consultation des factures";
$titlemodfact = "Crer ou modifier une facture ";
$titlecli="Crer le client";
$titleconsentree="Consultation des entr&eacute;es";
$titlereglerfact="Enregistrer un r&eacute;glement";
$titleconsdep="Consultation des d&eacute;penses";
$titleconscde="Consultation des commandes";
$titlemoduser="Crer ou modifier un utilisateur";
$titlecomplement="Compl&eacute;ter une facture";
$titleconspropal = "Consultation des propositions";
$titleuser = "Liste des utilisateurs";
$titlecreatclient = "Crer ou modifier un client";
$titleCreatExpense = "Cr&eacute;er une d&eacute;pense";
$titleModExpense = "Modifier une d&eacute;pense";
$titleCreatOrder = "Cr&eacute;er une commande";
$titleModOrder = "Modifier une commande";
$titleModPropal = "Modifier une proposition";
$titleCreatPropal = "Cr&eacute;er une proposition";
$titleConsStat = "Consultation des statistiques";
$titleConsRelance = "Consultation des relances";
$titlepropverscde = "Transformation d'une proposition en commande";


#constante message utilisateur
$searchby="Rechercher par";
$addligfact="Ajouter une ligne de facture ";
$adddep="Ajouter une d&eacute;pense ";
$addorder="Ajouter une commande ";
$addpropal = "Ajouter une proposition";
$sortby="Trier par ";

#message erreur ouv/execution
$errorconnect="Problme de connection";
$notokopen="Ouverture impossible";
$errorprepare="Prparation impossible";
$errorexecute="Excution impossible";

#date
$date="Date";
$dateprevision = "Date pr&eacute;visionnelle de facturation";
$datefacturation="Date&nbsp;&nbsp;facture";
$day="Jour";
$month="Mois";
$year="Ann&eacute;e";
$billdate="Date facture";
$regulationdate="Date de r&egrave;glement";
$orderdate="Date de commande";
$expensedate="Date dpense";
tie %hashmonth,"Tie::IxHash";
%hashmonth=("1" => "Janvier", "2" => "Fvrier", "3" => "Mars", "4" => "Avril",
"5" => "Mai", "6" => "Juin", "7" => "Juillet", "8" => "Aot", "9" => "Septembre",
"10" => "Octobre", "11" => "Novembre", "12" => "Dcembre");
$factureplusanc="Facture de plus de ";
$datelastrevival ="Date derni&egrave;re relance";
$propaldate = "Date de la proposition";

#argent
$profit="B&eacute;n&egrave";
$regulation="Entr&eacute;es";
$average="Moyenne";

$totalwithouttaxsort = "HT";
$totalwithtaxsort="TTC";
$totalwithouttax="MONTANT HT";
$totalwithtax="MONTANT TTC";
$sum="Somme totale";
$unitprice="PU";
$tva="TVA";
$pricemovement="Frais de livraison TTC";
$idcheque="Num&eacute;ro ch&egrave;que";
$bank="Banque";
$total= "Total";

$totalsort = "Total";
$nocheque="Paiement non renseign&eacute;";
$turnover="Chiffre d'affaires";
$expense="D&eacute;penses";

$modepaiement = "Mode de paiement";


#identit personnelle

$name = "Nom";
$customername="Client";
$passwd="Mot de passe";
$oldpassword=" Ancien mot de passe";
$newpassword=" Nouveau mot de passe";
$confirmpassword="Confirmation du mot de passe";
$id="N&deg;";
$idsort="Numro";
$name2="Complment du nom";
$namecommercial="Commercial";
$nameleadproject = "Chef de projet";
$namecli = "Nom client";
$responsable="Responsable client";
$contactfact="Contact interne";
$idclient="Numro client";
$mansupply= "Fournisseur";
$qualification="Qualification";
$nobody='aucun';
$idusersort="Numro utilisateur";
$iduser="Num&eacute;ro utilisateur";
$loginname="Login";
$role="R&ocirc;le";
$rolesort="Rle";
$countrevival="nombre de relances";
$wholename = "Nom complet";
$telecopie = "fax";

#adressage
$adress="Adresse";
$adress2="Adresse2";
$adress3="Adresse3";
$street="Rue";
$addresscomplement= "Compl&eacute;ment d'adresse";
$city="Ville";
$postal="Code postal";
$country="Pays";
$clientpostal="Code postal";
$state="Etat";
$telephone="T&eacute;l&eacute;phone";
$telephone2="T&eacute;l&eacute;phone 2";
$e_mail="E-mail";

#identite cde, facture, depenses,...
$billsend="Envoy&eacute";
$bill="Facture";
$billstatus="Statut facture";
$idorder="Num&eacute;ro commande";
$idordersort="Numro commande";
$idbill="Num&eacute;ro facture";
$idbillliste="Numro facture";
$orderreference="R&eacute;ference commande";
$orderreferencesort="Rference commande";
$idpropalsort="Numro proposition";
$idexpense = "Num&eacute;ro d&eacute;pense";

#quantite
$linenumber="Nombre de lignes";
$quantity="Quantit&eacute;";
$ontotal="sur un total de ";
$percentage=" nb / total";

#divers
$action="Action";
$select="S&eacute;lectionnez";
$wording= "Libell&eacute;";
$wordsort="Libell";
$all="tous";
$nosupply="Pas de fournisseur";
$commentaires = "Commentaire";
$propalestim = "Russite estime";
$selectpropalestim = "Estimez vos chances d'aboutir";
$giveorderref = "Donnez la rfrence";

#commentaires associs aux propal
$propal{"0"} = "Supprimer la proposition";
$propal{"0.1"} = "On y croit pas beaucoup";
$propal{"1"} = "C'est encore possible";
$propal{"5"} = "C'est jouable mais peu d'lment de jugement";
$propal{"10"} = "Aucun lment ngatif mais de la concurrence";
$propal{"20"} = "Le client est content mais il y a plusieurs concurrents";
$propal{"30"} = "Le client est content et on a un seul concurrent";
$propal{"40"} = "Le client est content et pas de concurrence";
$propal{"50"} = "Le client est content et doit faire valider";
$propal{"60"} = "En attente d'une dcision mais accord de principe";
$propal{"70"} = "La commande est acquise, aucun obstacle";
$propal{"80"} = "La commande est  la signature, tout est bon ";
$propal{"90"} = "La commande est partie de chez le client";
$propal{"100"} = "On a la proposition signe, cration commande";


#pour les chances de paiement
$dateech{"-1"} = "A rception de facture";
$dateech{"30"} = "30 jours";
$dateech{"30e"} = "30 jours fin de mois";
$dateech{"45"} = "45 jours";
$dateech{"60"} = "60 jours";
$dateech{"90"} = "90 jours";
$datepayment= "Date &eacute;ch&eacute;ance";
$dpayment = "Date chance";
$selectpayment = "Slectionnez l'chance";
$dayspayment = "Ech&eacute;ance";
$payment = "Echance";

#pour le mode de paiement
$modepaiement{"virement"} = "virement";
$modepaiement{"cheque"} = "chque";
$modepaiement{"espece"} = "espces";

#divers
$boamp = "BOAMP";
$chefprojetencours = "Chef de projet en cours de nomination";

1;

END{}

